'=================================================
'= Break and turning lights for radio controlled (analog) nitro car
'=                 Evert dekker 2007
'=================================================
'=    Copyright for commercial use, for private use have fun
'=================================================
'=      Version 1.0 29/5/2007 -  Bascom version 1.11.8.3
'=================================================

$regfile = "Attiny45.dat"
$crystal = 1000000
$eepleave
$hwstack = 40
$swstack = 16
$framesize = 40
Osccal = 87

'=== Dimension the variabele===
Dim Pulsgas As Word
Dim Pulsstuur As Word
Dim Keytime As Word
Dim Blightsetting As Eram Word At &H02
Dim Failsafesetting As Eram Word At &H04
Dim Counterclockwise As Eram Byte At &H06
Dim Turnlightoff As Eram Byte At &H08
Dim Linksaan As Byte , Rechtsaan As Byte , Knipper As Bit , Breaklight As Byte , Temp As Byte
Dim Timertoggle As Bit
Dim Niks As Byte

'===Setup the ports===
Config Timer0 = Timer , Prescale = 1024
Config Portb.1 = Output                                     ' Leds link uit
Config Portb.2 = Output                                     ' Leds rechts uit
Config Pinb.0 = Input                                       'Button in
On Ovf0 Isr_500m
Enable Ovf0
Enable Interrupts
Timer0 = &H0C
Start Timer0

'===Aliassen & constanten===
Ledlinks Alias Portb.2
Ledrechts Alias Portb.1
Setkey Alias Pinb.0
'===Set the port===
Set Pinb.0                                                  'Switch on the pull resistor for the key

'Open "comb.0:19200,8,n,1" For Output As #1

 '=== Main ===
If Setkey = 0 Then                                          ' If the key is pressed at startup
   If Counterclockwise = 1 Then                             ' Change the counterclockwise bit from 1 to 0 or 0 to 1
      Counterclockwise = 0
      Gosub Flashlights                                     ' Flash led's 1x for ack
    Else
      Counterclockwise = 1
      Gosub Flashlights                                     ' Flash led's 2x for ack
      Gosub Flashlights
   End If
End If
Bitwait Setkey , Set                                        ' Wait until the key is released


Do
Pulsein Pulsgas , Pinb , 3 , 1                              'Measure incoming pulselengte
Pulsein Pulsstuur , Pinb , 4 , 1
'Print #1 , Pulsstuur
Select Case Pulsstuur
Case Is < 65 : Linksaan = 0                                 'was 65
                Rechtsaan = 20
Case Is > 81 : Linksaan = 10
                Rechtsaan = 0


Case Else : Linksaan = 0
            Rechtsaan = 0
End Select
If Turnlightoff = 1 Then
Linksaan = 0
Rechtsaan = 0
End If

Gosub Breaklights
Temp = Breaklight + Linksaan
Temp = Temp + Rechtsaan
Temp = Temp + Knipper

Select Case Temp
Case 0 : Reset Ledlinks
          Reset Ledrechts
Case 1 : Reset Ledlinks
          Reset Ledrechts
Case 10 : Set Ledlinks
          Reset Ledrechts
Case 11 : Reset Ledlinks
          Reset Ledrechts
Case 100 : Set Ledlinks
            Set Ledrechts
Case 101 : Set Ledlinks
            Set Ledrechts
Case 110 : Set Ledlinks
           Set Ledrechts
Case 111 : Reset Ledlinks
            Set Ledrechts
Case 120 : Set Ledlinks
           Set Ledrechts
Case 121 : Set Ledlinks
            Reset Ledrechts
Case 20 : Set Ledrechts
            Reset Ledlinks
Case 21 : Reset Ledrechts
          Reset Ledlinks
End Select
If Setkey = 0 Then Gosub Keypressed

Loop
End


Isr_500m:
If Timertoggle = 1 Then
 Toggle Knipper
End If
Timer0 = &H0C
Toggle Timertoggle
Return


'===Subroutines===
Keypressed:
'Set Breaklight                                              'Switch the brake lights off else whe can't see the acknowledge
Waitms 30                                                   'Remove the debounce
Keytime = 0                                                 'Clear variabele
While Setkey = 0                                            ' Count until key is released
Incr Keytime
If Keytime > 64000 Then Keytime = 64000                     ' Pressed the key for a very long time...............
Waitms 2                                                    'Wait a little bit because the avr is fast
Wend
If Keytime > 100 And Keytime < 300 Then                     ' Key is short pressed
        Blightsetting = Pulsgas                             'Save setting in eeprom
       Gosub Flashlights
End If
If Keytime > 300 Then                                       'Key is long pressed
 If Turnlightoff > 0 Then
  Turnlightoff = 0
  Gosub Flashlights
  Gosub Flashlights
 Else
  Turnlightoff = 1
  Gosub Flashlights
  Gosub Flashlights
  Gosub Flashlights
End If
End If
Return

Breaklights:
If Counterclockwise = 0 Then                                ' Breaklights on when servo is turning clockwise
   If Pulsgas < Blightsetting Then                          ' If Pulse shorter then saved pulse lenght, then breaklight on
       Breaklight = 100
   Else
       Breaklight = 0
   End If
Else                                                        ' Breaklights on when servo is turning clockwise
If Pulsgas > Blightsetting Then                             ' If Pulse longer then saved pulse lenght, then breaklight on
       Breaklight = 100
   Else
       Breaklight = 0
   End If
End If

Return


Flashlights:
Waitms 150
Reset Ledlinks
Reset Ledrechts
Waitms 150
Set Ledlinks
Set Ledrechts
Waitms 150
Return